const tp = require('@tabletop-playground/api');
var Timer = require("easytimer.js").Timer;

const ui = new tp.UIElement();

ui.position = new tp.Vector(0, 0, 0.2);

const hb = new tp.HorizontalBox();
const digit1 = new tp.ImageWidget();
digit1.setImage("0.png").setImageSize(digit1.getImageFileWidth() / 4, digit1.getImageFileHeight() / 4);
hb.addChild(digit1);
const digit2 = new tp.ImageWidget();
digit2.setImage("0.png").setImageSize(digit2.getImageFileWidth() / 4, digit2.getImageFileHeight() / 4);
hb.addChild(digit2);
const divider = new tp.ImageWidget();
divider.setImage("divider.png").setImageSize(divider.getImageFileWidth() / 4, divider.getImageFileHeight() / 4);
hb.addChild(divider);
const digit3 = new tp.ImageWidget();
digit3.setImage("0.png").setImageSize(digit3.getImageFileWidth() / 4, digit3.getImageFileHeight() / 4);
hb.addChild(digit3);
const digit4 = new tp.ImageWidget();
digit4.setImage("0.png").setImageSize(digit4.getImageFileWidth() / 4, digit4.getImageFileHeight() / 4);
hb.addChild(digit4);
hb.setChildDistance(4);

const vb = new tp.VerticalBox();
const pbStart = new tp.Button().setText("Start/Stop");
pbStart.onClicked.add(() => {
    if (timer.isPaused() || !timer.isRunning()) {
        timer.start();
    } else {
        timer.pause();
    }
});
vb.addChild(pbStart);
const pbReset = new tp.Button().setText("Reset");
pbReset.onClicked.add(() => {
    timer.reset();
    timer.stop();
    printTime("00:00");
});
vb.addChild(pbReset);

hb.addChild(vb);

ui.scale = 1;
ui.widget = hb;

tp.refObject.addUI(ui);
const packageId = tp.refPackageId;

function printTime(time) {
    var [left, right] = time.split(':');
    right = right.split('.')[0];
    digit1.setImage(`${left.charAt(0)}.png`, packageId);
    digit2.setImage(`${left.charAt(1)}.png`, packageId);
    digit3.setImage(`${right.charAt(0)}.png`, packageId);
    digit4.setImage(`${right.charAt(1)}.png`, packageId);
}

const timer = new Timer({
    target: { minutes: 59, seconds: 59 },
    callback: () => {
        printTime(timer.getTimeValues().toString(['minutes', 'seconds']));
    }
});


