const tp = require('@tabletop-playground/api');
var Timer = require("easytimer.js").Timer;

const reDate = /^([0-5][0-9]):([0-5][0-9])$/;

const ui = new tp.UIElement();

ui.position = new tp.Vector(0, 0, 0.2);

const hb = new tp.HorizontalBox();
const digit1 = new tp.ImageWidget();
digit1.setImage("0.png").setImageSize(digit1.getImageFileWidth() / 4, digit1.getImageFileHeight() / 4);
hb.addChild(digit1);
const digit2 = new tp.ImageWidget();
digit2.setImage("0.png").setImageSize(digit2.getImageFileWidth() / 4, digit2.getImageFileHeight() / 4);
hb.addChild(digit2);
const divider = new tp.ImageWidget();
divider.setImage("divider.png").setImageSize(divider.getImageFileWidth() / 4, divider.getImageFileHeight() / 4);
hb.addChild(divider);
const digit3 = new tp.ImageWidget();
digit3.setImage("0.png").setImageSize(digit3.getImageFileWidth() / 4, digit3.getImageFileHeight() / 4);
hb.addChild(digit3);
const digit4 = new tp.ImageWidget();
digit4.setImage("0.png").setImageSize(digit4.getImageFileWidth() / 4, digit4.getImageFileHeight() / 4);
hb.addChild(digit4);
hb.setChildDistance(4);

const vb = new tp.VerticalBox();
const pbStart = new tp.Button().setText("Start/Stop");
pbStart.onClicked.add(() => {
    if (timer.isPaused() || !timer.isRunning()) {
        timer.start();
    } else {
        timer.pause();
    }
});
vb.addChild(pbStart);
const pbReset = new tp.Button().setText("Reset");
pbReset.onClicked.add(() => {
    timer.reset();
    printTime(timer.getTimeValues().toString(['minutes', 'seconds']));
    timer.stop();
});
vb.addChild(pbReset);

hb.addChild(vb);

const vb2 = new tp.VerticalBox();
const pbSet = new tp.Button().setText("  Set  ");
pbSet.onClicked.add(() => {
    if (tb.getParent()) {
        var isValid = reDate.test(tb.getText());
        if (isValid) {
            const m = tb.getText().match(reDate);
            timer.start({ startValues: { minutes: parseInt(m[1]), seconds: parseInt(m[2]) } });
            timer.pause();
            printTime(timer.getTimeValues().toString(['minutes', 'seconds']));
            vb2.removeChild(tb);
        }
    } else {
        vb2.addChild(tb);
    }
});
vb2.addChild(pbSet);

const tb = new tp.TextBox();
tb.setMaxLength = 5;
tb.setFontSize(14);
tb.setText("00:00");

hb.addChild(vb2);

ui.widget = hb;
tp.refObject.addUI(ui);
const packageId = tp.refPackageId;

function printTime(time) {
    var [left, right] = time.split(':');
    right = right.split('.')[0];
    digit1.setImage(`${left.charAt(0)}.png`, packageId);
    digit2.setImage(`${left.charAt(1)}.png`, packageId);
    digit3.setImage(`${right.charAt(0)}.png`, packageId);
    digit4.setImage(`${right.charAt(1)}.png`, packageId);
}

const timer = new Timer({
    countdown: true,
    startValues: { minutes: 1, seconds: 0 },
    callback: () => {
        printTime(timer.getTimeValues().toString(['minutes', 'seconds']));
    }
});

printTime(timer.getTimeValues().toString(['minutes', 'seconds']));
